# rax2react performance test

- order: 0

performance test

---

```js
/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Image from 'nuke-image';
import Picture from 'nuke-biz-picture';
import ListView from 'nuke-list-view';
import Button from 'nuke-button';

const dataTemplate = [
  {
    img: '//gw.alicdn.com/tfs/TB1Eu7BAFuWBuNjSszbXXcS7FXa-1500-592.png',
    text: '100K 大小的图片',
    background: '#4AF2A1'
  },
  {
    img: '//gw.alicdn.com/tfs/TB12Q8RCqmWBuNjy1XaXXXCbXXa-1571-922.png',
    text: '35K  大小的图片',
    background: '#B0F566'
  }
];
const dataTemplateNew = [
  {
    img: '//gw.alicdn.com/tfs/TB12Q8RCqmWBuNjy1XaXXXCbXXa-1571-922.png',
    text: '100K 大小的图片',
    background: '#6638F0'
  },
  {
    img: '//gw.alicdn.com/tfs/TB1Eu7BAFuWBuNjSszbXXcS7FXa-1500-592.png',
    text: '35K  大小的图片',
    background: '#F78AE0'
  }
];
let dataSource = [],
  newDataSource = [];
for (let i = 0; i < 100; i++) {
  dataSource = dataSource.concat(dataTemplate);
  newDataSource = newDataSource.concat(dataTemplateNew);
}
let startTime, endTime, preTime;

let App = class NukeDemoIndex extends Component {
  constructor() {
    super();
    this.state = {
      dataSource: []
    };
    preTime = new Date().getTime();
  }
  componentWillMount() {
    this.setState({
      dataSource: dataSource
    });
  }
  componentDidMount() {
    alert(new Date().getTime() - preTime);
  }
  resetNode = () => {
    startTime = new Date().getTime();
    this.setState({
      dataSource: newDataSource
    });
  };
  loaderMore = () => {
    for (let i = 0; i < 100; i++) {
      dataSource = dataSource.concat(dataTemplateNew);
    }
    this.setState({
      dataSource: dataSource
    });
  };
  componentDidUpdate() {
    endTime = new Date().getTime();
    alert(endTime - startTime);
  }
  renderHeader = () => {
    return (
      <View style={s.header}>
        <Button type="primary" onPress={this.resetNode}>
          重设节点
        </Button>
      </View>
    );
  };
  renderRow = (rowData, index) => {
    return (
      <View style={s.item}>
        <Image style={s.itemImg} src={rowData.img} />
        <View style={[s.textWrap, { backgroundColor: rowData.background }]}>
          <Text style={s.itemText}>{index}</Text>
          <Text style={s.itemText}>{rowData.text}</Text>
        </View>
      </View>
    );
  };
  render() {
    return (
      <ListView
        ref="mylist"
        style={s.list}
        renderHeader={this.renderHeader}
        renderRow={this.renderRow}
        dataSource={this.state.dataSource}
        onEndReached={this.loaderMore}
      />
    );
  }
};
const s = {
  list: {
    flex: 1
  },
  header: {
    width: 750,
    height: 100,
    backgroundColor: '#6638F0',
    justifyContent: 'center'
  },
  item: {
    flexDirection: 'row',
    width: 750,
    height: 200
  },
  itemImg: {
    width: 200,
    height: 200
  },
  textWrap: {
    width: 550,
    height: 200,
    justifyContent: 'center'
  },
  itemText: {
    fontSize: 28
  }
};
render(<App />);
```
